"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStableE = exports.useStableO = exports.useStable = void 0;
var E = require("fp-ts/Either");
var Eq = require("fp-ts/Eq");
var O = require("fp-ts/Option");
var react_1 = require("react");
var isSetStateFn = function (s) { return typeof s === 'function'; };
var useStable = function (initState, eq) {
    return react_1.useReducer(function (s1, s2) {
        var _s2 = isSetStateFn(s2) ? s2(s1) : s2;
        return eq.equals(s1, _s2) ? s1 : _s2;
    }, initState);
};
exports.useStable = useStable;
var useStableO = function (initState) {
    return exports.useStable(initState, O.getEq(Eq.eqStrict));
};
exports.useStableO = useStableO;
var useStableE = function (initState) {
    return exports.useStable(initState, E.getEq(Eq.eqStrict, Eq.eqStrict));
};
exports.useStableE = useStableE;
//# sourceMappingURL=state.js.map